//This file created by John Vogel's makeViews.tcl script.
//Please contact john.vogel123@gmail.com for comments or feature requests.
//
// View generation completed on 13:30:56_10_25_2010
// makeViews version: 0.10


`timescale 1ns/100ps

module test;

parameter CLKPERIOD = 100 ;
parameter SLOWCLKPERIOD = 100 ;
parameter SLOWCLKDELAY = 10 ;
parameter NUMCLKS = 500 ;
parameter RESETDELAY = 10 ;
parameter SCANCHAINLENGTH = 16 ;

reg CLK;
reg SLOWCLK;
reg RESETB;
reg scanin;
reg [SCANCHAINLENGTH-1:0] SCANINDATA;

wire scanout;

//JPV instantiating DUT
jpvDft DUT0 (
.CLK(CLK)
,.SLOWCLK(SLOWCLK)
,.RESETB(RESETB)
,.scanin(scanin)
,.scanout(scanout)
);

//JPV dump signals for analysis
initial
   begin
     $dumpvars(0,test);
   end

//JPV create clocks
initial
   begin
     #(CLKPERIOD/2) CLK='b0;
   forever
    #(CLKPERIOD/2) CLK = !CLK;
   end

initial
   begin
     #SLOWCLKDELAY
     #(SLOWCLKPERIOD/2) SLOWCLK='b0;
   forever
    #(SLOWCLKPERIOD/2) SLOWCLK = !SLOWCLK;
   end

//JPV initializing all inputs to x then 0 then calling resets
initial
   begin
     RESETB='bx;
     scanin='bx;
     SCANINDATA=16'hx;
    //JPV all stimulus off neg edge of clock
    #(CLKPERIOD/2) 
    #(CLKPERIOD) 
     RESETB='b1;
    resetRESETB; // reset DUT using RESETB
     SCANINDATA=16'h0000; scanInTask; checkScanOut;
     SCANINDATA=16'hffff; scanInTask; checkScanOut;
     SCANINDATA=16'hff00; scanInTask; checkScanOut;
     SCANINDATA=16'hf0f0; scanInTask; checkScanOut;
     SCANINDATA=16'hcccc; scanInTask; checkScanOut;
     SCANINDATA=16'haaaa; scanInTask; checkScanOut;
    #(5*CLKPERIOD);
    //$stop;
    $finish;
   end

//JPV scan data in task
   task scanInTask ;
	reg [SCANCHAINLENGTH/4 :0] i;

	begin
		i = 0;
		while (i < SCANCHAINLENGTH) begin
			@(negedge CLK) begin
			scanin = SCANINDATA[i];
			i = i + 1;
			end
		end
	end
   endtask

//JPV check scan out data
   task checkScanOut ;
	reg [SCANCHAINLENGTH/4 :0] i;

	begin
		i = 0;
		while (i < SCANCHAINLENGTH) begin
			@(posedge CLK) begin
			#25;
			if (SCANINDATA[i] != scanout) 
			$display("JPVERROR: At time %t index %d, scaninvalue = %h does not equal scanoutvalue = %h ", $time, i, SCANINDATA[i], scanout);
			else begin
			$display("JPVINFO: At time %t index %d, scaninvalue = %h and scanoutvalue = %h ", $time, i, SCANINDATA[i], scanout);
			end
			i = i + 1;
			end
		end
	end
   endtask

//JPV reset task
   task resetRESETB ;
      begin
        #(CLKPERIOD) RESETB=0;
        #(CLKPERIOD) RESETB=1;
      end
   endtask

endmodule //test
